<template functional>
  <div
    :ref="data.ref"
    class="[ a-cover-l ]"
    :class="[data.staticClass, data.class]"
    :style="[data.staticStyle, data.style]"
    v-bind="data.attrs"
    v-on="listeners"
  >
    <!--
      @slot The Cover child elements.
    -->
    <slot />
  </div>
</template>

<script>
export default {
  name: 'ACoverL',
};
</script>

<style>
.a-cover-l {
  --a-cover-l--def-min-h: 100vh; /* theme('minHeight.screen') */
  --a-cover-l--def-px: 0; /* theme('padding.0') */
  --a-cover-l--def-py: 0; /* theme('padding.0') */
  --a-cover-l--child--def-my: 0; /* theme('margin.0') */
}

.a-cover-l {
  display: flex;
  flex-direction: column;
}

.a-cover-l:not(.reset) {
  --cover-l--px: var(--a-cover-l--px, var(--a-cover-l--def-px));
  --cover-l--py: var(--a-cover-l--py, var(--a-cover-l--def-py));

  min-height: var(--a-cover-l--min-h, var(--a-cover-l--def-min-h));
  padding: var(--cover-l--py) var(--cover-l--px);
}

.a-cover-l > * {
  margin-top: var(--a-cover-l--child--my, var(--a-cover-l--child--def-my));
  margin-bottom: var(--a-cover-l--child--my, var(--a-cover-l--child--def-my));
}

.a-cover-l > :first-child:not([data-centered]) {
  margin-top: 0;
}

.a-cover-l > :last-child:not([data-centered]) {
  margin-bottom: 0;
}

.a-cover-l > [data-centered] {
  margin-top: auto;
  margin-bottom: auto;
}
</style>
